import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Background here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Background extends World
{ 
    private static final GreenfootImage bgImage = new GreenfootImage("Background.png"); 
    private static final int scrollSpeed = 4; 

    private GreenfootImage scrollingImage; 
    private int scrollPosition = 0; 

    public Background() 
    { 
        super(1000, 500, 1); 
        scrollingImage = getScrollingImage(800, 400); 

        addObject (new Player(), 350, 200);

        prepare();
    } 

    public void act() 
    { 
        if(scrollPosition < 0) { 
            scrollPosition = getWidth(); 
        }
        scrollPosition -= scrollSpeed; 
        paint(scrollPosition); 
        if ( Greenfoot.getRandomNumber(100) <1)
        {
            addObject( new SportsCarRight(), 30, 300);
        }
        if ( Greenfoot.getRandomNumber(100) <1)
        {
            addObject( new SportsCarLeft(), 970, 200);
        }
        if ( Greenfoot.getRandomNumber(100) <1)
        {
            addObject( new Frog(), 970, 100);
        }
        if ( Greenfoot.getRandomNumber(100) <1)
        {
            addObject( new Frog(), 970, 400);
        }
    }

    private void paint(int position) 
    { 
        GreenfootImage bg = getBackground(); 
        bg.drawImage(scrollingImage, position, 0); 
        if(position > 0) { 
            bg.drawImage(scrollingImage, position - scrollingImage.getWidth(), 0); 
        } 
        else { 
            bg.drawImage(scrollingImage, position + scrollingImage.getWidth(), 0); 
        } 
    } 

    private GreenfootImage getScrollingImage(int width, int height) 
    { 
        GreenfootImage image = new GreenfootImage(width, height); 
        for(int x = 0; x < width; x += bgImage.getWidth()) { 
            for(int y = 0; y < height; y += bgImage.getHeight()) { 
                image.drawImage(bgImage, x, y); 
            } 
        } 
        return image; 
    } 

    private void prepare()
    {

    }
}
